#coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Windows面板
# +-------------------------------------------------------------------
# | Copyright (c) 2015-2016 宝塔软件(http://www.bt.cn) All rights reserved.
# +-------------------------------------------------------------------
# | Author: 沐落 <cjx@bt.cn>
# +-------------------------------------------------------------------

#------------------------------
# SSL接口
#------------------------------
import public,os,sys,binascii,urllib,json,time,datetime,re

class panelSSL:
    #__APIURL = 'http://www.bt.cn/api/AuthCloud';
    __APIURL = 'http://www.bt.cn/api/Auth';
    __APIURL2 = 'http://www.bt.cn/api/Cert'
    __UPATH = 'data/userInfo.json';
    __userInfo = None;
    __PDATA = None;
    setupPath = None #安装路径
    
    #构造方法
    def __init__(self):
        self.setupPath = public.GetConfigValue('setup_path')
        pdata = {}
        data = {}
        if os.path.exists(self.__UPATH):
            try:
                self.__userInfo = json.loads(public.readFile(self.__UPATH));
                if self.__userInfo:
                    pdata['access_key'] = self.__userInfo['access_key'];
                    data['secret_key'] = self.__userInfo['secret_key'];
            except :
                self.__userInfo = None        
        else:
            pdata['access_key'] = 'test';
            data['secret_key'] = '123456';
        pdata['data'] = data;
        self.__PDATA = pdata;
    
    def GetToken(self,get):
        """
        登录官网获取Token
        @get.username 官网手机号
        @get.password 官网账号密码
        """
        rtmp = ""
        data = {}
        data['username'] = get.username;
        data['password'] = public.md5(get.password);
        pdata = {}
        pdata['data'] = self.De_Code(data);
        try:
            rtmp = public.httpPost(self.__APIURL+'/GetToken',pdata)
            result = json.loads(rtmp);
            result['data'] = self.En_Code(result['data']);
            if result['data']: 
                public.writeFile(self.__UPATH,json.dumps(result['data']));
                if os.path.exists('data/bind_path.pl'): os.remove('data/bind_path.pl')

            del(result['data']);

            try:                
                if hasattr(get,'panel_ltd'):  
                    ltd = int(get.panel_ltd)
                    if ltd:                        
                        import panelAuth,panelPlugin
                        from common import dict_obj
                        
                        nget = dict_obj();
                        nget.pid = 100000046
                        nget.cycle = 1
                        ret = panelAuth.panelAuth().get_buy_code(nget)           

                        tget = dict_obj();
                        tget.force = 1
                        ret = panelPlugin.panelPlugin().get_soft_list(tget)
            except : pass
                       
            return result;
        except Exception as ex:
            return public.returnMsg(False,'连接服务器失败!<br>' + str(rtmp))
    
    def DelToken(self,get):
        """
        删除授权token
        """
        if os.path.exists(self.__UPATH):            
            os.remove(self.__UPATH)
        return public.returnMsg(True,"SSL_BTUSER_UN");
        
    def GetUserInfo(self,get):
        """
        获取用户信息
        """
        result = {}
        if self.__userInfo:
            userTmp = {}
            userTmp['username'] = self.__userInfo['username'][0:3]+'****'+self.__userInfo['username'][-4:];
            result['status'] = True;
            result['msg'] = public.getMsg('SSL_GET_SUCCESS');
            result['data'] = userTmp;
        else:
            userTmp = {}
            userTmp['username'] = public.getMsg('SSL_NOT_BTUSER');
            result['status'] = False;
            result['msg'] = public.getMsg('SSL_NOT_BTUSER');
            result['data'] = userTmp;
        return result;

    def GetOrderList(self,get):         
        """
        获取SSL订单列表
        @get.focre 开启本地缓存
        @get.siteName 网站名称

        """
  
        get.focre = 1;

        focre  = 0
        if hasattr(get,'force'): focre = int(get.force)
        lcoalTmp = 'data/ssl_order_list.json'
     
        result = None
        #if os.path.exists(lcoalTmp): result = json.loads(public.readFile(lcoalTmp))

        if not result or  focre > 0:
            lcoalTmp = 'data/ssl_order_list.json'
            if hasattr(get,'siteName'):
                path =  self.setupPath + '/panel/vhost/cert/'+ get.siteName + '/partnerOrderId';
                if os.path.exists(path):
                    self.__PDATA['data']['partnerOrderId'] = public.readFile(path);
        
            self.__PDATA['data'] = self.De_Code(self.__PDATA['data']);
            data = ""
            try:
                data = public.httpPost(self.__APIURL + '/GetSSLList',self.__PDATA)
                result = json.loads(data)
            except Exception as ex:
                return public.returnMsg(False,'连接服务器失败!<br>' + str(data)) 

            result['data'] = self.En_Code(result['data']);
            for i in range(len(result['data'])):
                result['data'][i]['endtime'] =   self.add_months(result['data'][i]['createTime'],result['data'][i]['validityPeriod'])
          
            if result: public.writeFile(lcoalTmp,json.dumps(result))

        return result;

    
    def add_months(self,dt,months):
        """
        计算日期增加(月)
        """
        import calendar
        dt = datetime.datetime.fromtimestamp(dt/1000);
        month = dt.month - 1 + months
        year = dt.year + month // 12
        month = month % 12 + 1

        day = min(dt.day,calendar.monthrange(year,month)[1])
        return (time.mktime(dt.replace(year=year, month=month, day=day).timetuple()) + 86400) * 1000
    
    def CheckDvDomain(self,get):
        """
        检测是否本机申请证书
        """
        pid = public.M('domain').where('name=?',(get.domain,)).getField('pid');
        return pid

    
    def GetDVSSL(self,get):
        """
        申请证书
        """
        get.id = public.M('domain').where('name=?',(get.domain,)).getField('pid');
        if hasattr(get,'siteName'):
            get.path = public.M('sites').where('id=?',(get.id,)).getField('path');
        else:
            get.siteName = public.M('sites').where('id=?',(get.id,)).getField('name');
        
        #当申请二级域名为www时，检测主域名是否绑定到同一网站
        if get.domain[:4] == 'www.':
            if not public.M('domain').where('name=? AND pid=?',(get.domain[4:],get.id)).count():
                return public.returnMsg(False,"申请[%s]证书需要验证[%s]请将[%s]绑定并解析到站点!" % (get.domain,get.domain[4:],get.domain[4:]))
        
        runPath = self.GetRunPath(get);
        print(runPath)
        if runPath != False and runPath != '/': get.path +=  runPath;
        authfile = get.path + '/.well-known/pki-validation/fileauth.txt';
        if not self.CheckDomain(get):
            if not os.path.exists(authfile): 
                return public.returnMsg(False,'无法写入验证文件: {}'.format(authfile))
            else:
                msg = '''无法正确访问验证文件<br><a class="btlink" href="{c_url}" target="_blank">{c_url}</a> <br><br>
                <p></b>可能的原因：</b></p>
                1、未正确解析，或解析未生效 [请正确解析域名，或等待解析生效后重试]<br>
                2、检查是否有设置301/302重定向 [请暂时关闭重定向相关配置]<br>
                3、检查该网站是否已部署HTTPS并设置强制HTTPS [请暂时关闭强制HTTPS功能]<br>'''.format(c_url = self._check_url)
                return public.returnMsg(False,msg)
            
        action = 'GetDVSSL';
        if hasattr(get,'partnerOrderId'):
            self.__PDATA['data']['partnerOrderId'] = get.partnerOrderId;
            action = 'ReDVSSL';
        
        self.__PDATA['data']['domain'] = get.domain;
        self.__PDATA['data'] = self.De_Code(self.__PDATA['data']);
        result = public.httpPost(self.__APIURL + '/' + action,self.__PDATA)
        try:
            result = json.loads(result);
        except: return result;
        result['data'] = self.En_Code(result['data']);
      
        if 'authValue' in result['data']:            
            public.writeFile(authfile,result['data']['authValue']);
        return result;
    
    #获取运行目录
    def GetRunPath(self,get):
        if hasattr(get,'siteName'):
            get.id = public.M('sites').where('name=?',(get.siteName,)).getField('id');
        else:
            get.id = public.M('sites').where('path=?',(get.path,)).getField('id');
        if not get.id: return False;
        import panelSite
        result = panelSite.panelSite().GetSiteRunPath(get);
        if 'runPath' in result:            
            return result['runPath'];
        return '/'
    
    #检查域名是否解析
    def CheckDomain(self,get):
        try:
            #创建目录
            spath = get.path + '/.well-known/pki-validation'
            if not os.path.exists(spath): os.makedirs(spath)

            #生成并写入检测内容
            epass = public.GetRandomString(32)
            public.writeFile(spath + '/fileauth.txt',epass)

            #检测目标域名访问结果
            if get.domain[:4] == 'www.':   #申请二级域名为www时检测主域名
                get.domain = get.domain[4:]

            import http_requests
            self._check_url = 'http://' + get.domain + '/.well-known/pki-validation/fileauth.txt'            
            result = http_requests.get(self._check_url,s_type='curl').text
            self.__test = result
            if result == epass: return True
            print(result)
            return False
        except:
            print(public.get_error_info())
            return False
    
    #确认域名
    def Completed(self,get):
        self.__PDATA['data']['partnerOrderId'] = get.partnerOrderId;
        self.__PDATA['data'] = self.De_Code(self.__PDATA['data']);
        if hasattr(get,'siteName'):
            get.path = public.M('sites').where('name=?',(get.siteName,)).getField('path');
            runPath = self.GetRunPath(get);
            if runPath != False and runPath != '/': get.path +=  runPath;
           
            sslInfo = json.loads(public.httpPost(self.__APIURL + '/SyncOrder',self.__PDATA));
            
            sslInfo['data'] = self.En_Code(sslInfo['data']);  
            try:
                public.writeFile(get.path + '/.well-known/pki-validation/fileauth.txt',sslInfo['data']['authValue']);
            except:
                return public.returnMsg(False,'SSL_CHECK_WRITE_ERR');       
        public.httpPost(self.__APIURL + '/Completed',self.__PDATA)     

        n = 0
        while True:
            if n > 5: break  
            try:
                time.sleep(5)           
                rRet = json.loads(public.httpPost(self.__APIURL + '/SyncOrder',self.__PDATA));
           
                rRet['data'] = self.En_Code(rRet['data']);
                if rRet['data']['stateCode'] == 'COMPLETED': break                
                n += 1
            except : pass

        return rRet;
    
    #同步指定订单
    def SyncOrder(self,get):
        self.__PDATA['data']['partnerOrderId'] = get.partnerOrderId;
        self.__PDATA['data'] = self.De_Code(self.__PDATA['data']);
        result = json.loads(public.httpPost(self.__APIURL + '/SyncOrder',self.__PDATA));
        result['data'] = self.En_Code(result['data']);
        return result;
    
    #获取证书
    def GetSSLInfo(self,get):
        self.__PDATA['data']['partnerOrderId'] = get.partnerOrderId;
        self.__PDATA['data'] = self.De_Code(self.__PDATA['data']);

        serverType = public.get_webserver(); 
        if serverType == 'iis':   
            result = public.httpPost(self.__APIURL + '/GetPKCS12',self.__PDATA)
        else:
            result = public.httpPost(self.__APIURL + '/GetSSLInfo',self.__PDATA)
        result = json.loads(result)
        result['data'] = self.En_Code(result['data']);
       
        #写配置到站点
        if hasattr(get,'siteName'):            
            try:
                if result['status']:                    
                    siteName = get.siteName;
                    path = self.setupPath + '/panel/vhost/cert/'+ siteName;
                    if not os.path.exists(path): os.makedirs(path)
                    pidpath = path + "/partnerOrderId";
                    if serverType == 'iis':   
                        pwdpath = path + "/password"
                        pfxpath = path + "/fullchain.pfx"
                        import base64
                        public.writeFile(pwdpath,result['data']['password'])
                        #写入pfx证书
                        public.writeFile2(pfxpath,base64.b64decode(result['data']['fileData']),'wb+')

                        #处理一个网站多个域名证书
                        get.certPath = pfxpath
                        get.password = result['data']['password']
                        cert_data = self.GetCertName(get)
                        if cert_data:
                            domain = cert_data['dns'][0]
                            if domain.find("*") < 0:                        
                                if len(cert_data['dns']) > 1 : domain = cert_data['dns'][len(cert_data['dns']) - 1]
                    
                                pwdpath = path + "/" + domain
                                pfxpath = path + "/" + domain + ".pfx"

                                public.writeFile(pwdpath,result['data']['password'])
                                public.writeFile2(pfxpath,base64.b64decode(result['data']['fileData']),'wb+')

                    elif serverType == 'apache':
                        path = os.getenv("BT_SETUP") + '/apache/conf/ssl/' + siteName 
                        if not os.path.exists(path): os.makedirs(path)

                        csrpath = path + "/fullchain.pem";
                        keypath = path + "/privkey.pem";

                        public.writeFile(keypath,result['data']['privateKey']);
                        public.writeFile(csrpath,result['data']['cert'] + result['data']['certCa']);

                    else:
                        path = os.getenv("BT_SETUP") + '/nginx/conf/ssl/' + siteName 
                        if not os.path.exists(path): os.makedirs(path)

                        csrpath = path + "/fullchain.pem";
                        keypath = path + "/privkey.pem";

                        public.writeFile(keypath,result['data']['privateKey'].strip());
                        public.writeFile(csrpath,result['data']['cert'] + result['data']['certCa'].strip());

                    public.writeFile(pidpath,get.partnerOrderId);
                    import panelSite
                    result = panelSite.panelSite().SetSSLConf(get);         
                    return result;
                else:
                    return public.returnMsg(False,result['msg']);
            except Exception as ex:               
                return public.returnMsg(False,'SET_ERROR,' + str(ex));
        return result;
    
    #部署证书夹证书
    def SetCertToSite(self,get):
        try:
            import shutil
            siteName = get.siteName;
            path = self.setupPath + '/panel/vhost/cert/'+ siteName;
            if not os.path.exists(path): os.makedirs(path)         

            d_path = self.setupPath + '/panel/vhost/ssl/' + get.certName
            d_path = d_path.replace("*.","")

            serverType = public.get_webserver(); 
            if serverType == 'iis':    
                shutil.copyfile( d_path + "/fullchain.pfx",path + '/fullchain.pfx')
                if os.path.exists(d_path + '/password'): shutil.copyfile(d_path + '/password',path + '/password')
            else:
                npath = os.getenv("BT_SETUP") + '/' + serverType + '/conf/ssl/' + siteName 
                if not os.path.exists(npath): os.makedirs(npath)

                shutil.copyfile( d_path + "/fullchain.pem",npath + '/fullchain.pem')
                shutil.copyfile( d_path + "/privkey.pem",npath + '/privkey.pem')

            if os.path.exists(path + '/partnerOrderId'): os.remove(path + '/partnerOrderId')
            if os.path.exists(d_path + '/partnerOrderId'): shutil.copyfile(d_path + '/partnerOrderId',path + '/partnerOrderId')

            import panelSite
            ret = panelSite.panelSite().SetSSLConf(get);
            if ret['status']:                
                public.serviceReload();
                return public.returnMsg(True,'SET_SUCCESS');
            return ret
        except Exception as ex:
            return public.returnMsg(False,'SET_ERROR,' + str(ex));
    
    #获取证书列表
    def GetCertList(self,get):
        try:
            vpath = self.setupPath + '/panel/vhost/ssl'
            if not os.path.exists(vpath): os.makedirs(vpath)
            data = []
            for d in os.listdir(vpath):
                mpath = vpath + '/' + d + '/info.json';
           
                if not os.path.exists(mpath): continue;
                tmp = public.readFile(mpath)
                if not tmp: continue;
                tmp1 = json.loads(tmp)
                data.append(tmp1)
            return data;
        except:
            return [];
    
    #删除证书
    def RemoveCert(self,get):
        try:
            vpath = self.setupPath + '/panel/vhost/ssl/' + get.certName
            vpath = vpath.replace("*.","")
            if not os.path.exists(vpath): return public.returnMsg(False,'证书不存在!');
            import shutil
            shutil.rmtree(vpath)
            return public.returnMsg(True,'证书已删除!');
        except:
            return public.returnMsg(False,'删除失败!');
    
    #保存证书
    def SaveCert(self,get):
        try:
            certInfo = self.GetCertName(get)
            if not certInfo: return public.returnMsg(False,'证书解析失败!');
            vpath = self.setupPath + '/panel/vhost/ssl/' + certInfo['subject'];           
            if not os.path.exists(vpath):  os.makedirs(vpath);

            vpath = vpath.replace("*.","")
            serverType = public.get_webserver(); 
            if serverType == 'iis': 
                import shutil
                if get.password: public.writeFile(vpath + '/password',get.password)
                shutil.copyfile(get.certPath,vpath + '/fullchain.pfx')
                if hasattr(get,'local'):
                    local_path = self.setupPath + '/panel/vhost/cert/localhost'
                    if not os.path.exists(local_path):  os.makedirs(local_path);

                    shutil.copyfile(get.certPath,local_path + '/fullchain.pfx')
            else:              
                public.writeFile(vpath + '/privkey.pem',public.readFile(get.keyPath));
                public.writeFile(vpath + '/fullchain.pem',public.readFile(get.certPath));
            public.writeFile(vpath + '/info.json',json.dumps(certInfo));

            if os.path.exists(vpath + '/partnerOrderId'): os.remove(vpath + '/partnerOrderId')       
            if get.partnerOrderId: public.writeFile(vpath + '/partnerOrderId',get.partnerOrderId)

            return public.returnMsg(True,'证书保存成功!');
        except:
            return public.returnMsg(False,'证书保存失败!');
    
    #拆分根证书
    def split_ca_data(self,cert):
        datas = cert.split('-----END CERTIFICATE-----')
        return {"cert":datas[0] + "-----END CERTIFICATE-----\n","ca_data":datas[1] + '-----END CERTIFICATE-----\n' }

        #获取证书哈希
    def get_cert_data(self,cret_data):

        from OpenSSL import crypto 

        x509 = crypto.load_certificate(crypto.FILETYPE_PEM, cret_data)
            
        buffs = x509.digest('sha1')
        hash =  bytes.decode(buffs).replace(':','')
        data = {}
        data['hash'] = hash
        data['timeout'] = self.strfToTime(bytes.decode(x509.get_notAfter())[:-1])
        data['unix_timeout'] = self.get_unixtime(data['timeout'],"%Y-%m-%d")
  
        return data

    def get_unixtime(self,data,format = "%Y-%m-%d %H:%M:%S"):

        import time
        timeArray = time.strptime(data,format )

        timeStamp = int(time.mktime(timeArray))
        return timeStamp

    #获取证书名称
    def GetCertName(self,get):
        try:                  
            try:
                from OpenSSL import crypto 
                from urllib3.contrib import pyopenssl as reqs
            except :
                os.system(public.get_run_pip('[PIP] install crypto'))
                os.system(public.get_run_pip('[PIP] install pyopenssl'))

                from OpenSSL import crypto 
                from urllib3.contrib import pyopenssl as reqs
            
            certPath = get.certPath     
            if os.path.exists(certPath):
                data = {}
                f = open(certPath,'rb') 
                pfx_buffer = f.read() 
                cret_data = pfx_buffer
                if certPath[-4:] == '.pfx':   
                    if hasattr(get, 'password'):
                        password = get.password
                        if password:                            
                            p12 = crypto.load_pkcs12(pfx_buffer,get.password)
                        else:
                            p12 = crypto.load_pkcs12(pfx_buffer)
                    else:
                        p12 = crypto.load_pkcs12(pfx_buffer)
                    x509 = p12.get_certificate()
                    data['type'] = 'pfx'     
                else:
                    #验证域名证书和跟证书顺序       
                    try:
                        cert_data = self.split_ca_data(public.readFile(certPath))

                        cert_d1 = self.get_cert_data(cert_data['cert'])
                        cert_d2 = self.get_cert_data(cert_data['ca_data'])
                        if cert_d1['unix_timeout'] > cert_d2['unix_timeout']:
                            print(cert_d1['unix_timeout'])
                            public.writeFile(certPath,cert_data['ca_data'] + cert_data['cert'])
                            f = open(certPath,'rb') 
                            pfx_buffer = f.read()
                    except :pass

                    x509 = crypto.load_certificate(crypto.FILETYPE_PEM, pfx_buffer)
                    data['type'] = 'pem'
                buffs = x509.digest('sha1')            
                data['hash'] =  bytes.decode(buffs).replace(':','')
                data['number'] = x509.get_serial_number()
                issuser = x509.get_issuer()

                is_key = 'O'
                if len(issuser.get_components()) == 1: is_key = 'CN'                
                for item in issuser.get_components():                 
                    if bytes.decode(item[0]) == is_key:                   
                        data['issuer'] = bytes.decode(item[1])
                        break
            
                data['notAfter'] = self.strfToTime(bytes.decode( x509.get_notAfter())[:-1])
                data['notBefore'] = self.strfToTime(bytes.decode(x509.get_notBefore())[:-1])
                data['version'] = x509.get_version()
                data['timeout'] = x509.has_expired()
                x509name = x509.get_subject()
                data['subject'] = x509name.commonName.replace('*','_')
                data['dns'] = []
                alts = reqs.get_subj_alt_name(x509)
                for x in alts:  
                    data['dns'].append(x[1])
              
            return data;
        except:
            return None;
    
    #转换时间
    def strfToTime(self,sdate):
        import time
        return time.strftime('%Y-%m-%d',time.strptime(sdate,'%Y%m%d%H%M%S'))
        
    #获取产品列表
    def GetSSLProduct(self,get):
        self.__PDATA['data'] = self.De_Code(self.__PDATA['data']);
        result = json.loads(public.httpPost(self.__APIURL + '/GetSSLProduct',self.__PDATA));
        result['data'] = self.En_Code(result['data']);
        return result;
    
    #加密数据
    def De_Code(self,data):
        if sys.version_info[0] == 2:
            pdata = urllib.urlencode(data);
        else:
            pdata = urllib.parse.urlencode(data);
            if type(pdata) == str: pdata = pdata.encode('utf-8')
        return binascii.hexlify(pdata);
    
    #解密数据
    def En_Code(self,data):
        if sys.version_info[0] == 2:
            result = urllib.unquote(binascii.unhexlify(data));
        else:
            if type(data) == str: data = data.encode('utf-8')
            tmp = binascii.unhexlify(data)
            if type(tmp) != str: tmp = tmp.decode('utf-8')
            result = urllib.parse.unquote(tmp)

        if type(result) != str: result = result.decode('utf-8')
        return json.loads(result);
    
    # 手动一键续签
    def renew_lets_ssl(self, get):
        if not os.path.exists('vhost/crontab.json'):  
            return public.returnMsg(False,'当前没有可以续订的证书!')      
        
        old_list = json.loads(public.ReadFile("vhost/crontab.json"))
        cron_list = old_list
        if hasattr(get, 'siteName'):
            if not get.siteName in old_list:
                return public.returnMsg(False,'当前网站没有可以续订的证书.')  
            cron_list = {}
            cron_list[get.siteName] = old_list[get.siteName]

        import panelLets
        lets = panelLets.panelLets()

        result = {}
        result['status'] = True
        result['sucess_list']  = []
        result['err_list'] = []
        for siteName in cron_list:
            data = cron_list[siteName]
           
            ret = lets.renew_lest_cert(data)
            if ret['status']:
                result['sucess_list'].append(siteName)
            else:
                result['err_list'].append({"siteName":siteName,"msg":ret['msg']})
        return result;
    
    #获取产品列表
    def get_product_list(self,get):
        result = self.request('get_product_list')
        return result

    #获取商业证书订单列表
    def get_order_list(self,get):
        result = self.request('get_order_list')
        return result

    #获指定商业证书订单
    def get_order_find(self,get):
        self.__PDATA['data']['oid'] = get.oid
        result = self.request('get_order_find')
        return result

    #下载证书
    def download_cert(self,get):
        self.__PDATA['data']['oid'] = get.oid
        result = self.request('download_cert')
        return result

    #部署指定商业证书
    def set_cert(self,get):
        siteName = get.siteName
        certInfo = self.get_order_find(get)
        print(certInfo)
        path = self.setupPath + '/panel/vhost/cert/' + siteName
        if not os.path.exists(path): os.makedirs(path)
        pidpath = path+"/certOrderId"

        serverType = public.get_webserver(); 
        if serverType == 'iis':   
            pwdpath = path + "/password"
            pfxpath = path + "/fullchain.pfx"
            import base64
            password = certInfo['pkcsPass']
            public.writeFile(pwdpath,password)
            #写入pfx证书
            public.writeFile2(pfxpath,base64.b64decode(certInfo['pkcs12']),'wb+')

            #处理一个网站多个域名证书
            get.certPath = pfxpath
            get.password = password
            cert_data = self.GetCertName(get)
            if cert_data:
                domain = cert_data['dns'][0]
                if domain.find("*") < 0:                        
                    if len(cert_data['dns']) > 1 : domain = cert_data['dns'][len(cert_data['dns']) - 1]
                    
                    pwdpath = path + "/" + domain
                    pfxpath = path + "/" + domain + ".pfx"

                    public.writeFile(pwdpath,password)
                    public.writeFile2(pfxpath,base64.b64decode(certInfo['pkcs12']),'wb+')
                    public.writeFile(pidpath,get.oid)

        elif serverType == 'apache':
            path = os.getenv("BT_SETUP") + '/apache/conf/ssl/' + siteName 
            if not os.path.exists(path): os.makedirs(path)

            csrpath = path + "/fullchain.pem";
            keypath = path + "/privkey.pem";

            public.writeFile(keypath,certInfo['privateKey'])
            public.writeFile(csrpath,certInfo['certificate']+"\n"+certInfo['caCertificate'])
            public.writeFile(pidpath,get.oid)

        else:
            path = os.getenv("BT_SETUP") + '/nginx/conf/ssl/' + siteName 
            if not os.path.exists(path): os.makedirs(path)

            csrpath = path + "/fullchain.pem";
            keypath = path + "/privkey.pem";

            public.writeFile(keypath,certInfo['privateKey'])
            public.writeFile(csrpath,certInfo['certificate']+"\n"+certInfo['caCertificate'])
            public.writeFile(pidpath,get.oid)

        other_file = path + '/partnerOrderId'
        if os.path.exists(other_file): os.remove(other_file)
        other_file = path + '/README'
        if os.path.exists(other_file): os.remove(other_file)

        import panelSite
        ret = panelSite.panelSite().SetSSLConf(get)
        if not ret['status']: return ret
            
        public.serviceReload(siteName)
        return public.returnMsg(True,'SET_SUCCESS')
        
    #生成商业证书支付订单
    def apply_order_pay(self,args):
        self.__PDATA['data'] = json.loads(args.pdata)
        result = self.request('apply_cert_order')
        return result

    #检查商业证书支付状态
    def get_pay_status(self,args):
        self.__PDATA['data']['oid'] = args.oid
        result = self.request('get_pay_status')
        return result

    #提交商业证书订单到CA
    def apply_order(self,args):
        self.__PDATA['data']['oid'] = args.oid
        result = self.request('apply_cert')
        if result['status'] == True:
            self.__PDATA['data'] = {}
            result['verify_info'] = self.get_verify_info(args)
        return result

    #获取商业证书验证信息
    def get_verify_info(self,args):
        self.__PDATA['data']['oid'] = args.oid
        verify_info = self.request('get_verify_info')
        is_file_verify = 'fileName' in verify_info
        verify_info['paths'] = []
        verify_info['hosts'] = []
        for domain in verify_info['domains']:
            if is_file_verify:
                siteRunPath = self.get_domain_run_path(domain)
                if not siteRunPath:
                    if domain[:4] == 'www.': domain = domain[:4]
                    verify_info['paths'].append(verify_info['path'].replace('example.com',domain))
                    continue
                verify_path = siteRunPath + '/.well-known/pki-validation'
                if not os.path.exists(verify_path):
                    os.makedirs(verify_path)
                verify_file = verify_path + '/' + verify_info['fileName']
                if os.path.exists(verify_file): continue
                public.writeFile(verify_file,verify_info['content'])
            else:
                if domain[:4] == 'www.': domain = domain[:4]
                verify_info['hosts'].append(verify_info['host'] + '.' + domain)
        return verify_info

    #处理验证信息
    def set_verify_info(self,args):
        verify_info = self.get_verify_info(args)
        is_file_verify = 'fileName' in verify_info
        verify_info['paths'] = []
        verify_info['hosts'] = []
        for domain in verify_info['domains']:
            if domain[:2] == '*.': domain = domain[2:]
            if is_file_verify:
                siteRunPath = self.get_domain_run_path(domain)
                if not siteRunPath:
                    if domain[:4] == 'www.': domain = domain[4:]
                    verify_info['paths'].append(verify_info['path'].replace('example.com',domain))
                    continue
                verify_path = siteRunPath + '/.well-known/pki-validation'
                if not os.path.exists(verify_path):
                    os.makedirs(verify_path)
                verify_file = verify_path + '/' + verify_info['fileName']
                if os.path.exists(verify_file): continue
                public.writeFile(verify_file,verify_info['content'])
            else:
                if domain[:4] == 'www.': domain = domain[4:]
                verify_info['hosts'].append(verify_info['host'] + '.' + domain)
        return verify_info


    #获取指定域名的PATH
    def get_domain_run_path(self,domain):
        pid = public.M('domain').where('name=?',(domain,)).getField('pid')
        if not pid: return False
        return self.get_site_run_path(pid)


    def get_site_run_path(self,pid):
        '''
            @name 获取网站运行目录
            @author hwliang<2020-08-05>
            @param pid(int) 网站标识
            @return string
        '''
        siteInfo = public.M('sites').where('id=?',(pid,)).find()
        siteName = siteInfo['name']
        sitePath = siteInfo['path']
        webserver_type = public.get_webserver()
        setupPath = self.setupPath

        import panelSite        
        info = panelSite.panelSite().get_site_info(siteName)
        
        return info['path']
    
    #验证URL是否匹配
    def check_url_txt(self,args):
        url = args.url
        content = args.content

        import http_requests 
        res = http_requests.get(url,s_type='curl',timeout=6)
        result = res.text
        if not result: return 0       
        
        if result.find('11001') != -1 or result.find('curl: (6)') != -1: return -1
        if result.find('curl: (7)') != -1 or res.status_code in [403,401]: return -5
        if result.find('Not Found') != -1 or result.find('not found') != -1 or res.status_code in [404]:return -2
        if result.find('timed out') != -1:return -3
        if result.find('301') != -1 or result.find('302') != -1 or result.find('Redirecting...') != -1 or res.status_code in [301,302]:return -4
        if result == content:return 1
        return 0


    #获取商业证书验证结果
    def get_verify_result(self,args):
        self.__PDATA['data']['oid'] = args.oid
        verify_info = self.request('get_verify_result')
        if verify_info['status'] in ['COMPLETE',False]: return verify_info
        is_file_verify = 'CNAME_CSR_HASH' != verify_info['data']['dcvList'][0]['dcvMethod']
        verify_info['paths'] = []
        verify_info['hosts'] = []
        if verify_info['data']['application']['status'] == 'ongoing':
            return public.returnMsg(False,'订单出现问题，CA正在人工验证，若24小时内依然出现此提示，请联系宝塔')
        for dinfo in verify_info['data']['dcvList']:
            is_https = dinfo['dcvMethod'] == 'HTTPS_CSR_HASH'
            if is_https:
                is_https = 's'
            else:
                is_https = ''
            domain = dinfo['domainName']
            if domain[:2] == '*.': domain = domain[2:]
            dinfo['domainName'] = domain
            if is_file_verify:
                siteRunPath = self.get_domain_run_path(domain)
                
                if domain[:4] == 'www.': domain = domain[4:] 

                status = 0
                url = 'http'+ is_https +'://'+ domain +'/.well-known/pki-validation/' + verify_info['data']['DCVfileName']
                get = public.dict_obj()
                get.url = url
                get.content = verify_info['data']['DCVfileContent']
                status = self.check_url_txt(get)                

                verify_info['paths'].append({'url':url,'status':status})
                if not siteRunPath: continue

                verify_path = siteRunPath + '/.well-known/pki-validation'
                if not os.path.exists(verify_path):
                    os.makedirs(verify_path)
                verify_file = verify_path + '/' + verify_info['data']['DCVfileName']
                if os.path.exists(verify_file): continue
                public.writeFile(verify_file,verify_info['data']['DCVfileContent'])
            else:
                if domain[:4] == 'www.': domain = domain[4:]
                verify_info['hosts'].append(verify_info['data']['DCVdnsHost'] + '.' + domain)

        return verify_info

    #更换验证方式
    def again_verify(self,args):
        self.__PDATA['data']['oid'] = args.oid
        self.__PDATA['data']['dcvMethod'] = args.dcvMethod
        result = self.request('again_verify')
        return result 

    #取消订单
    def cancel_cert_order(self,args):
        self.__PDATA['data']['oid'] = args.oid
        result = self.request('cancel_cert_order')
        return result
    
    #发送请求
    def request(self,dname):
        self.__PDATA['data'] = json.dumps(self.__PDATA['data'])
        try:
            result = public.httpPost(self.__APIURL2 + '/' + dname,self.__PDATA)
            result = json.loads(result)
        except:
            pass
        return result